/* enigma/crypt() , modified */

#include "config.h"

#define ROTORSZ 256
#define MASK 0377

char	t1[ROTORSZ];
char	t2[ROTORSZ];
char	t3[ROTORSZ];
char	deck[ROTORSZ];
char	buf[13];
int	b;

void	enigma (char *, int);
void	shuffle(char *);
void	setup(char *);

void setup(char *pw) {
	int ic, i, k, temp, pf[2];
	unsigned rnd;
	long seed;

	strncpy(buf, pw, sizeof(buf)-1);
	while (*pw)
		*pw++ = '\0';
	buf[8] = buf[0];
	buf[9] = buf[1];
	pipe(pf);
	write(pf[1], buf, 10);
	close(pf[1]);
	seed = 123;
	for (i=0; i<13; i++)
		seed = seed*buf[i] + i;
	for(i=0;i<ROTORSZ;i++) {
		t1[i] = i;
		deck[i] = i;
	}
	for(i=0;i<ROTORSZ;i++) {
		seed = 5*seed + buf[i%13];
		if( sizeof(long) > 4 )  {
			/* Force seed to stay in 32-bit signed math */
			if( seed & 0x80000000 )
				seed = seed | (-1L & ~0xFFFFFFFFL);
			else
				seed &= 0x7FFFFFFF;
		}
		rnd = seed % 65521;
		k = ROTORSZ-1 - i;
		ic = (rnd&MASK)%(k+1);
		rnd >>= 8;
		temp = t1[k];
		t1[k] = t1[ic];
		t1[ic] = temp;
		if(t3[k]!=0) continue;
		ic = (rnd&MASK) % k;
		while(t3[ic]!=0) ic = (ic+1) % k;
		t3[k] = ic;
		t3[ic] = k;
	}
	for(i=0;i<ROTORSZ;i++)
		t2[t1[i]&MASK] = i;
}

void enigma(char tocrypt[], int length) {
	register int i, a, n1, n2, nr1, nr2;
	extern char enicrypt[256];
	char pw[strlen(enc_pw)];

	strncpy(pw, enc_pw, strlen(enc_pw));

	if(b==0) { 
		setup(pw); b++;
	}
                                                                                      
	a = i = n1 = n2 = nr2 = 0;

	while(a < length) {
	i=tocrypt[a];

			nr1 = deck[n1]&MASK;
			nr2 = deck[nr1]&MASK;
		i = t2[(t3[(t1[(i+nr1)&MASK]+nr2)&MASK]-nr2)&MASK]-nr1;

		enicrypt[a]=i;

		n1++;
		if(n1==ROTORSZ) {
			n1 = 0;
			n2++;
			if(n2==ROTORSZ) n2 = 0;
				shuffle(deck);
		}

	a++;
	}
	enicrypt[length]='\0';

}

void shuffle(char deckary[]) {
	int i, ic, k, temp;
	unsigned rnd;
	static long seed = 123;

	for(i=0;i<ROTORSZ;i++) {
		seed = 5*seed + buf[i%13];
		rnd = seed % 65521;
		k = ROTORSZ-1 - i;
		ic = (rnd&MASK)%(k+1);
		temp = deckary[k];
		deckary[k] = deckary[ic];
		deckary[ic] = temp;
	}
}
